// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from multisensor_calibration_interface:msg/CalibrationResult.idl
// generated code does not contain a copyright notice
#include "multisensor_calibration_interface/msg/detail/calibration_result__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `src_frame_id`
// Member `ref_frame_id`
// Member `base_frame_id`
#include "rosidl_runtime_c/string_functions.h"
// Member `sensor_extrinsics`
#include "geometry_msgs/msg/detail/transform__functions.h"

bool
multisensor_calibration_interface__msg__CalibrationResult__init(multisensor_calibration_interface__msg__CalibrationResult * msg)
{
  if (!msg) {
    return false;
  }
  // is_successful
  // src_frame_id
  if (!rosidl_runtime_c__String__init(&msg->src_frame_id)) {
    multisensor_calibration_interface__msg__CalibrationResult__fini(msg);
    return false;
  }
  // ref_frame_id
  if (!rosidl_runtime_c__String__init(&msg->ref_frame_id)) {
    multisensor_calibration_interface__msg__CalibrationResult__fini(msg);
    return false;
  }
  // base_frame_id
  if (!rosidl_runtime_c__String__init(&msg->base_frame_id)) {
    multisensor_calibration_interface__msg__CalibrationResult__fini(msg);
    return false;
  }
  // sensor_extrinsics
  if (!geometry_msgs__msg__Transform__init(&msg->sensor_extrinsics)) {
    multisensor_calibration_interface__msg__CalibrationResult__fini(msg);
    return false;
  }
  return true;
}

void
multisensor_calibration_interface__msg__CalibrationResult__fini(multisensor_calibration_interface__msg__CalibrationResult * msg)
{
  if (!msg) {
    return;
  }
  // is_successful
  // src_frame_id
  rosidl_runtime_c__String__fini(&msg->src_frame_id);
  // ref_frame_id
  rosidl_runtime_c__String__fini(&msg->ref_frame_id);
  // base_frame_id
  rosidl_runtime_c__String__fini(&msg->base_frame_id);
  // sensor_extrinsics
  geometry_msgs__msg__Transform__fini(&msg->sensor_extrinsics);
}

bool
multisensor_calibration_interface__msg__CalibrationResult__are_equal(const multisensor_calibration_interface__msg__CalibrationResult * lhs, const multisensor_calibration_interface__msg__CalibrationResult * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // is_successful
  if (lhs->is_successful != rhs->is_successful) {
    return false;
  }
  // src_frame_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->src_frame_id), &(rhs->src_frame_id)))
  {
    return false;
  }
  // ref_frame_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->ref_frame_id), &(rhs->ref_frame_id)))
  {
    return false;
  }
  // base_frame_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->base_frame_id), &(rhs->base_frame_id)))
  {
    return false;
  }
  // sensor_extrinsics
  if (!geometry_msgs__msg__Transform__are_equal(
      &(lhs->sensor_extrinsics), &(rhs->sensor_extrinsics)))
  {
    return false;
  }
  return true;
}

bool
multisensor_calibration_interface__msg__CalibrationResult__copy(
  const multisensor_calibration_interface__msg__CalibrationResult * input,
  multisensor_calibration_interface__msg__CalibrationResult * output)
{
  if (!input || !output) {
    return false;
  }
  // is_successful
  output->is_successful = input->is_successful;
  // src_frame_id
  if (!rosidl_runtime_c__String__copy(
      &(input->src_frame_id), &(output->src_frame_id)))
  {
    return false;
  }
  // ref_frame_id
  if (!rosidl_runtime_c__String__copy(
      &(input->ref_frame_id), &(output->ref_frame_id)))
  {
    return false;
  }
  // base_frame_id
  if (!rosidl_runtime_c__String__copy(
      &(input->base_frame_id), &(output->base_frame_id)))
  {
    return false;
  }
  // sensor_extrinsics
  if (!geometry_msgs__msg__Transform__copy(
      &(input->sensor_extrinsics), &(output->sensor_extrinsics)))
  {
    return false;
  }
  return true;
}

multisensor_calibration_interface__msg__CalibrationResult *
multisensor_calibration_interface__msg__CalibrationResult__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__msg__CalibrationResult * msg = (multisensor_calibration_interface__msg__CalibrationResult *)allocator.allocate(sizeof(multisensor_calibration_interface__msg__CalibrationResult), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(multisensor_calibration_interface__msg__CalibrationResult));
  bool success = multisensor_calibration_interface__msg__CalibrationResult__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
multisensor_calibration_interface__msg__CalibrationResult__destroy(multisensor_calibration_interface__msg__CalibrationResult * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    multisensor_calibration_interface__msg__CalibrationResult__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
multisensor_calibration_interface__msg__CalibrationResult__Sequence__init(multisensor_calibration_interface__msg__CalibrationResult__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__msg__CalibrationResult * data = NULL;

  if (size) {
    data = (multisensor_calibration_interface__msg__CalibrationResult *)allocator.zero_allocate(size, sizeof(multisensor_calibration_interface__msg__CalibrationResult), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = multisensor_calibration_interface__msg__CalibrationResult__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        multisensor_calibration_interface__msg__CalibrationResult__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
multisensor_calibration_interface__msg__CalibrationResult__Sequence__fini(multisensor_calibration_interface__msg__CalibrationResult__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      multisensor_calibration_interface__msg__CalibrationResult__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

multisensor_calibration_interface__msg__CalibrationResult__Sequence *
multisensor_calibration_interface__msg__CalibrationResult__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__msg__CalibrationResult__Sequence * array = (multisensor_calibration_interface__msg__CalibrationResult__Sequence *)allocator.allocate(sizeof(multisensor_calibration_interface__msg__CalibrationResult__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = multisensor_calibration_interface__msg__CalibrationResult__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
multisensor_calibration_interface__msg__CalibrationResult__Sequence__destroy(multisensor_calibration_interface__msg__CalibrationResult__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    multisensor_calibration_interface__msg__CalibrationResult__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
multisensor_calibration_interface__msg__CalibrationResult__Sequence__are_equal(const multisensor_calibration_interface__msg__CalibrationResult__Sequence * lhs, const multisensor_calibration_interface__msg__CalibrationResult__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!multisensor_calibration_interface__msg__CalibrationResult__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
multisensor_calibration_interface__msg__CalibrationResult__Sequence__copy(
  const multisensor_calibration_interface__msg__CalibrationResult__Sequence * input,
  multisensor_calibration_interface__msg__CalibrationResult__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(multisensor_calibration_interface__msg__CalibrationResult);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    multisensor_calibration_interface__msg__CalibrationResult * data =
      (multisensor_calibration_interface__msg__CalibrationResult *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!multisensor_calibration_interface__msg__CalibrationResult__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          multisensor_calibration_interface__msg__CalibrationResult__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!multisensor_calibration_interface__msg__CalibrationResult__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
