// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from multisensor_calibration_interface:msg/CalibrationResult.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/msg/calibration_result.hpp"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__CALIBRATION_RESULT__TRAITS_HPP_
#define MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__CALIBRATION_RESULT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "multisensor_calibration_interface/msg/detail/calibration_result__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'sensor_extrinsics'
#include "geometry_msgs/msg/detail/transform__traits.hpp"

namespace multisensor_calibration_interface
{

namespace msg
{

inline void to_flow_style_yaml(
  const CalibrationResult & msg,
  std::ostream & out)
{
  out << "{";
  // member: is_successful
  {
    out << "is_successful: ";
    rosidl_generator_traits::value_to_yaml(msg.is_successful, out);
    out << ", ";
  }

  // member: src_frame_id
  {
    out << "src_frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.src_frame_id, out);
    out << ", ";
  }

  // member: ref_frame_id
  {
    out << "ref_frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.ref_frame_id, out);
    out << ", ";
  }

  // member: base_frame_id
  {
    out << "base_frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.base_frame_id, out);
    out << ", ";
  }

  // member: sensor_extrinsics
  {
    out << "sensor_extrinsics: ";
    to_flow_style_yaml(msg.sensor_extrinsics, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CalibrationResult & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: is_successful
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_successful: ";
    rosidl_generator_traits::value_to_yaml(msg.is_successful, out);
    out << "\n";
  }

  // member: src_frame_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "src_frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.src_frame_id, out);
    out << "\n";
  }

  // member: ref_frame_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ref_frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.ref_frame_id, out);
    out << "\n";
  }

  // member: base_frame_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "base_frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.base_frame_id, out);
    out << "\n";
  }

  // member: sensor_extrinsics
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_extrinsics:\n";
    to_block_style_yaml(msg.sensor_extrinsics, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CalibrationResult & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace multisensor_calibration_interface

namespace rosidl_generator_traits
{

[[deprecated("use multisensor_calibration_interface::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const multisensor_calibration_interface::msg::CalibrationResult & msg,
  std::ostream & out, size_t indentation = 0)
{
  multisensor_calibration_interface::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use multisensor_calibration_interface::msg::to_yaml() instead")]]
inline std::string to_yaml(const multisensor_calibration_interface::msg::CalibrationResult & msg)
{
  return multisensor_calibration_interface::msg::to_yaml(msg);
}

template<>
inline const char * data_type<multisensor_calibration_interface::msg::CalibrationResult>()
{
  return "multisensor_calibration_interface::msg::CalibrationResult";
}

template<>
inline const char * name<multisensor_calibration_interface::msg::CalibrationResult>()
{
  return "multisensor_calibration_interface/msg/CalibrationResult";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::msg::CalibrationResult>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<multisensor_calibration_interface::msg::CalibrationResult>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<multisensor_calibration_interface::msg::CalibrationResult>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__CALIBRATION_RESULT__TRAITS_HPP_
