// generated from rosidl_typesupport_introspection_c/resource/idl__type_support.c.em
// with input from multisensor_calibration_interface:msg/CalibrationResult.idl
// generated code does not contain a copyright notice

#include <stddef.h>
#include "multisensor_calibration_interface/msg/detail/calibration_result__rosidl_typesupport_introspection_c.h"
#include "multisensor_calibration_interface/msg/rosidl_typesupport_introspection_c__visibility_control.h"
#include "rosidl_typesupport_introspection_c/field_types.h"
#include "rosidl_typesupport_introspection_c/identifier.h"
#include "rosidl_typesupport_introspection_c/message_introspection.h"
#include "multisensor_calibration_interface/msg/detail/calibration_result__functions.h"
#include "multisensor_calibration_interface/msg/detail/calibration_result__struct.h"


// Include directives for member types
// Member `src_frame_id`
// Member `ref_frame_id`
// Member `base_frame_id`
#include "rosidl_runtime_c/string_functions.h"
// Member `sensor_extrinsics`
#include "geometry_msgs/msg/transform.h"
// Member `sensor_extrinsics`
#include "geometry_msgs/msg/detail/transform__rosidl_typesupport_introspection_c.h"

#ifdef __cplusplus
extern "C"
{
#endif

void multisensor_calibration_interface__msg__CalibrationResult__rosidl_typesupport_introspection_c__CalibrationResult_init_function(
  void * message_memory, enum rosidl_runtime_c__message_initialization _init)
{
  // TODO(karsten1987): initializers are not yet implemented for typesupport c
  // see https://github.com/ros2/ros2/issues/397
  (void) _init;
  multisensor_calibration_interface__msg__CalibrationResult__init(message_memory);
}

void multisensor_calibration_interface__msg__CalibrationResult__rosidl_typesupport_introspection_c__CalibrationResult_fini_function(void * message_memory)
{
  multisensor_calibration_interface__msg__CalibrationResult__fini(message_memory);
}

static rosidl_typesupport_introspection_c__MessageMember multisensor_calibration_interface__msg__CalibrationResult__rosidl_typesupport_introspection_c__CalibrationResult_message_member_array[5] = {
  {
    "is_successful",  // name
    rosidl_typesupport_introspection_c__ROS_TYPE_BOOLEAN,  // type
    0,  // upper bound of string
    NULL,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(multisensor_calibration_interface__msg__CalibrationResult, is_successful),  // bytes offset in struct
    NULL,  // default value
    NULL,  // size() function pointer
    NULL,  // get_const(index) function pointer
    NULL,  // get(index) function pointer
    NULL,  // fetch(index, &value) function pointer
    NULL,  // assign(index, value) function pointer
    NULL  // resize(index) function pointer
  },
  {
    "src_frame_id",  // name
    rosidl_typesupport_introspection_c__ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    NULL,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(multisensor_calibration_interface__msg__CalibrationResult, src_frame_id),  // bytes offset in struct
    NULL,  // default value
    NULL,  // size() function pointer
    NULL,  // get_const(index) function pointer
    NULL,  // get(index) function pointer
    NULL,  // fetch(index, &value) function pointer
    NULL,  // assign(index, value) function pointer
    NULL  // resize(index) function pointer
  },
  {
    "ref_frame_id",  // name
    rosidl_typesupport_introspection_c__ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    NULL,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(multisensor_calibration_interface__msg__CalibrationResult, ref_frame_id),  // bytes offset in struct
    NULL,  // default value
    NULL,  // size() function pointer
    NULL,  // get_const(index) function pointer
    NULL,  // get(index) function pointer
    NULL,  // fetch(index, &value) function pointer
    NULL,  // assign(index, value) function pointer
    NULL  // resize(index) function pointer
  },
  {
    "base_frame_id",  // name
    rosidl_typesupport_introspection_c__ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    NULL,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(multisensor_calibration_interface__msg__CalibrationResult, base_frame_id),  // bytes offset in struct
    NULL,  // default value
    NULL,  // size() function pointer
    NULL,  // get_const(index) function pointer
    NULL,  // get(index) function pointer
    NULL,  // fetch(index, &value) function pointer
    NULL,  // assign(index, value) function pointer
    NULL  // resize(index) function pointer
  },
  {
    "sensor_extrinsics",  // name
    rosidl_typesupport_introspection_c__ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    NULL,  // members of sub message (initialized later)
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(multisensor_calibration_interface__msg__CalibrationResult, sensor_extrinsics),  // bytes offset in struct
    NULL,  // default value
    NULL,  // size() function pointer
    NULL,  // get_const(index) function pointer
    NULL,  // get(index) function pointer
    NULL,  // fetch(index, &value) function pointer
    NULL,  // assign(index, value) function pointer
    NULL  // resize(index) function pointer
  }
};

static const rosidl_typesupport_introspection_c__MessageMembers multisensor_calibration_interface__msg__CalibrationResult__rosidl_typesupport_introspection_c__CalibrationResult_message_members = {
  "multisensor_calibration_interface__msg",  // message namespace
  "CalibrationResult",  // message name
  5,  // number of fields
  sizeof(multisensor_calibration_interface__msg__CalibrationResult),
  false,  // has_any_key_member_
  multisensor_calibration_interface__msg__CalibrationResult__rosidl_typesupport_introspection_c__CalibrationResult_message_member_array,  // message members
  multisensor_calibration_interface__msg__CalibrationResult__rosidl_typesupport_introspection_c__CalibrationResult_init_function,  // function to initialize message memory (memory has to be allocated)
  multisensor_calibration_interface__msg__CalibrationResult__rosidl_typesupport_introspection_c__CalibrationResult_fini_function  // function to terminate message instance (will not free memory)
};

// this is not const since it must be initialized on first access
// since C does not allow non-integral compile-time constants
static rosidl_message_type_support_t multisensor_calibration_interface__msg__CalibrationResult__rosidl_typesupport_introspection_c__CalibrationResult_message_type_support_handle = {
  0,
  &multisensor_calibration_interface__msg__CalibrationResult__rosidl_typesupport_introspection_c__CalibrationResult_message_members,
  get_message_typesupport_handle_function,
  &multisensor_calibration_interface__msg__CalibrationResult__get_type_hash,
  &multisensor_calibration_interface__msg__CalibrationResult__get_type_description,
  &multisensor_calibration_interface__msg__CalibrationResult__get_type_description_sources,
};

ROSIDL_TYPESUPPORT_INTROSPECTION_C_EXPORT_multisensor_calibration_interface
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_c, multisensor_calibration_interface, msg, CalibrationResult)() {
  multisensor_calibration_interface__msg__CalibrationResult__rosidl_typesupport_introspection_c__CalibrationResult_message_member_array[4].members_ =
    ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_c, geometry_msgs, msg, Transform)();
  if (!multisensor_calibration_interface__msg__CalibrationResult__rosidl_typesupport_introspection_c__CalibrationResult_message_type_support_handle.typesupport_identifier) {
    multisensor_calibration_interface__msg__CalibrationResult__rosidl_typesupport_introspection_c__CalibrationResult_message_type_support_handle.typesupport_identifier =
      rosidl_typesupport_introspection_c__identifier;
  }
  return &multisensor_calibration_interface__msg__CalibrationResult__rosidl_typesupport_introspection_c__CalibrationResult_message_type_support_handle;
}
#ifdef __cplusplus
}
#endif
