// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from multisensor_calibration_interface:msg/MarkerObservations.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/msg/marker_observations.hpp"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__MARKER_OBSERVATIONS__STRUCT_HPP_
#define MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__MARKER_OBSERVATIONS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'marker_top_left_point'
#include "geometry_msgs/msg/detail/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__multisensor_calibration_interface__msg__MarkerObservations __attribute__((deprecated))
#else
# define DEPRECATED__multisensor_calibration_interface__msg__MarkerObservations __declspec(deprecated)
#endif

namespace multisensor_calibration_interface
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MarkerObservations_
{
  using Type = MarkerObservations_<ContainerAllocator>;

  explicit MarkerObservations_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit MarkerObservations_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _marker_ids_type =
    std::vector<uint32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint32_t>>;
  _marker_ids_type marker_ids;
  using _marker_top_left_point_type =
    std::vector<geometry_msgs::msg::Point_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Point_<ContainerAllocator>>>;
  _marker_top_left_point_type marker_top_left_point;

  // setters for named parameter idiom
  Type & set__marker_ids(
    const std::vector<uint32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint32_t>> & _arg)
  {
    this->marker_ids = _arg;
    return *this;
  }
  Type & set__marker_top_left_point(
    const std::vector<geometry_msgs::msg::Point_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Point_<ContainerAllocator>>> & _arg)
  {
    this->marker_top_left_point = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator> *;
  using ConstRawPtr =
    const multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__multisensor_calibration_interface__msg__MarkerObservations
    std::shared_ptr<multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__multisensor_calibration_interface__msg__MarkerObservations
    std::shared_ptr<multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MarkerObservations_ & other) const
  {
    if (this->marker_ids != other.marker_ids) {
      return false;
    }
    if (this->marker_top_left_point != other.marker_top_left_point) {
      return false;
    }
    return true;
  }
  bool operator!=(const MarkerObservations_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MarkerObservations_

// alias to use template instance with default allocator
using MarkerObservations =
  multisensor_calibration_interface::msg::MarkerObservations_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace multisensor_calibration_interface

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__MARKER_OBSERVATIONS__STRUCT_HPP_
