// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from multisensor_calibration_interface:msg/MarkerObservations.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/msg/marker_observations.hpp"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__MARKER_OBSERVATIONS__TRAITS_HPP_
#define MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__MARKER_OBSERVATIONS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "multisensor_calibration_interface/msg/detail/marker_observations__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'marker_top_left_point'
#include "geometry_msgs/msg/detail/point__traits.hpp"

namespace multisensor_calibration_interface
{

namespace msg
{

inline void to_flow_style_yaml(
  const MarkerObservations & msg,
  std::ostream & out)
{
  out << "{";
  // member: marker_ids
  {
    if (msg.marker_ids.size() == 0) {
      out << "marker_ids: []";
    } else {
      out << "marker_ids: [";
      size_t pending_items = msg.marker_ids.size();
      for (auto item : msg.marker_ids) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: marker_top_left_point
  {
    if (msg.marker_top_left_point.size() == 0) {
      out << "marker_top_left_point: []";
    } else {
      out << "marker_top_left_point: [";
      size_t pending_items = msg.marker_top_left_point.size();
      for (auto item : msg.marker_top_left_point) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MarkerObservations & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: marker_ids
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.marker_ids.size() == 0) {
      out << "marker_ids: []\n";
    } else {
      out << "marker_ids:\n";
      for (auto item : msg.marker_ids) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: marker_top_left_point
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.marker_top_left_point.size() == 0) {
      out << "marker_top_left_point: []\n";
    } else {
      out << "marker_top_left_point:\n";
      for (auto item : msg.marker_top_left_point) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MarkerObservations & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace multisensor_calibration_interface

namespace rosidl_generator_traits
{

[[deprecated("use multisensor_calibration_interface::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const multisensor_calibration_interface::msg::MarkerObservations & msg,
  std::ostream & out, size_t indentation = 0)
{
  multisensor_calibration_interface::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use multisensor_calibration_interface::msg::to_yaml() instead")]]
inline std::string to_yaml(const multisensor_calibration_interface::msg::MarkerObservations & msg)
{
  return multisensor_calibration_interface::msg::to_yaml(msg);
}

template<>
inline const char * data_type<multisensor_calibration_interface::msg::MarkerObservations>()
{
  return "multisensor_calibration_interface::msg::MarkerObservations";
}

template<>
inline const char * name<multisensor_calibration_interface::msg::MarkerObservations>()
{
  return "multisensor_calibration_interface/msg/MarkerObservations";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::msg::MarkerObservations>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<multisensor_calibration_interface::msg::MarkerObservations>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<multisensor_calibration_interface::msg::MarkerObservations>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__MARKER_OBSERVATIONS__TRAITS_HPP_
