// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from multisensor_calibration_interface:msg/StampedFloat32MultiArray.idl
// generated code does not contain a copyright notice
#include "multisensor_calibration_interface/msg/detail/stamped_float32_multi_array__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `array`
#include "std_msgs/msg/detail/float32_multi_array__functions.h"

bool
multisensor_calibration_interface__msg__StampedFloat32MultiArray__init(multisensor_calibration_interface__msg__StampedFloat32MultiArray * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    multisensor_calibration_interface__msg__StampedFloat32MultiArray__fini(msg);
    return false;
  }
  // array
  if (!std_msgs__msg__Float32MultiArray__init(&msg->array)) {
    multisensor_calibration_interface__msg__StampedFloat32MultiArray__fini(msg);
    return false;
  }
  return true;
}

void
multisensor_calibration_interface__msg__StampedFloat32MultiArray__fini(multisensor_calibration_interface__msg__StampedFloat32MultiArray * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // array
  std_msgs__msg__Float32MultiArray__fini(&msg->array);
}

bool
multisensor_calibration_interface__msg__StampedFloat32MultiArray__are_equal(const multisensor_calibration_interface__msg__StampedFloat32MultiArray * lhs, const multisensor_calibration_interface__msg__StampedFloat32MultiArray * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // array
  if (!std_msgs__msg__Float32MultiArray__are_equal(
      &(lhs->array), &(rhs->array)))
  {
    return false;
  }
  return true;
}

bool
multisensor_calibration_interface__msg__StampedFloat32MultiArray__copy(
  const multisensor_calibration_interface__msg__StampedFloat32MultiArray * input,
  multisensor_calibration_interface__msg__StampedFloat32MultiArray * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // array
  if (!std_msgs__msg__Float32MultiArray__copy(
      &(input->array), &(output->array)))
  {
    return false;
  }
  return true;
}

multisensor_calibration_interface__msg__StampedFloat32MultiArray *
multisensor_calibration_interface__msg__StampedFloat32MultiArray__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__msg__StampedFloat32MultiArray * msg = (multisensor_calibration_interface__msg__StampedFloat32MultiArray *)allocator.allocate(sizeof(multisensor_calibration_interface__msg__StampedFloat32MultiArray), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(multisensor_calibration_interface__msg__StampedFloat32MultiArray));
  bool success = multisensor_calibration_interface__msg__StampedFloat32MultiArray__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
multisensor_calibration_interface__msg__StampedFloat32MultiArray__destroy(multisensor_calibration_interface__msg__StampedFloat32MultiArray * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    multisensor_calibration_interface__msg__StampedFloat32MultiArray__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__init(multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__msg__StampedFloat32MultiArray * data = NULL;

  if (size) {
    data = (multisensor_calibration_interface__msg__StampedFloat32MultiArray *)allocator.zero_allocate(size, sizeof(multisensor_calibration_interface__msg__StampedFloat32MultiArray), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = multisensor_calibration_interface__msg__StampedFloat32MultiArray__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        multisensor_calibration_interface__msg__StampedFloat32MultiArray__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__fini(multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      multisensor_calibration_interface__msg__StampedFloat32MultiArray__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence *
multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * array = (multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence *)allocator.allocate(sizeof(multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__destroy(multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__are_equal(const multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * lhs, const multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!multisensor_calibration_interface__msg__StampedFloat32MultiArray__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__copy(
  const multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * input,
  multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(multisensor_calibration_interface__msg__StampedFloat32MultiArray);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    multisensor_calibration_interface__msg__StampedFloat32MultiArray * data =
      (multisensor_calibration_interface__msg__StampedFloat32MultiArray *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!multisensor_calibration_interface__msg__StampedFloat32MultiArray__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          multisensor_calibration_interface__msg__StampedFloat32MultiArray__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!multisensor_calibration_interface__msg__StampedFloat32MultiArray__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
