// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from multisensor_calibration_interface:msg/TargetPose.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/msg/target_pose.hpp"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__TARGET_POSE__TRAITS_HPP_
#define MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__TARGET_POSE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "multisensor_calibration_interface/msg/detail/target_pose__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'target_pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace multisensor_calibration_interface
{

namespace msg
{

inline void to_flow_style_yaml(
  const TargetPose & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: is_detection
  {
    out << "is_detection: ";
    rosidl_generator_traits::value_to_yaml(msg.is_detection, out);
    out << ", ";
  }

  // member: target_pose
  {
    out << "target_pose: ";
    to_flow_style_yaml(msg.target_pose, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TargetPose & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: is_detection
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_detection: ";
    rosidl_generator_traits::value_to_yaml(msg.is_detection, out);
    out << "\n";
  }

  // member: target_pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "target_pose:\n";
    to_block_style_yaml(msg.target_pose, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TargetPose & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace multisensor_calibration_interface

namespace rosidl_generator_traits
{

[[deprecated("use multisensor_calibration_interface::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const multisensor_calibration_interface::msg::TargetPose & msg,
  std::ostream & out, size_t indentation = 0)
{
  multisensor_calibration_interface::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use multisensor_calibration_interface::msg::to_yaml() instead")]]
inline std::string to_yaml(const multisensor_calibration_interface::msg::TargetPose & msg)
{
  return multisensor_calibration_interface::msg::to_yaml(msg);
}

template<>
inline const char * data_type<multisensor_calibration_interface::msg::TargetPose>()
{
  return "multisensor_calibration_interface::msg::TargetPose";
}

template<>
inline const char * name<multisensor_calibration_interface::msg::TargetPose>()
{
  return "multisensor_calibration_interface/msg/TargetPose";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::msg::TargetPose>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Pose>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<multisensor_calibration_interface::msg::TargetPose>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Pose>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<multisensor_calibration_interface::msg::TargetPose>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__TARGET_POSE__TRAITS_HPP_
