// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from multisensor_calibration_interface:srv/AddMarkerObservations.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/srv/add_marker_observations.hpp"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__ADD_MARKER_OBSERVATIONS__STRUCT_HPP_
#define MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__ADD_MARKER_OBSERVATIONS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'observation'
#include "multisensor_calibration_interface/msg/detail/marker_observations__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__multisensor_calibration_interface__srv__AddMarkerObservations_Request __attribute__((deprecated))
#else
# define DEPRECATED__multisensor_calibration_interface__srv__AddMarkerObservations_Request __declspec(deprecated)
#endif

namespace multisensor_calibration_interface
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct AddMarkerObservations_Request_
{
  using Type = AddMarkerObservations_Request_<ContainerAllocator>;

  explicit AddMarkerObservations_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : observation(_init)
  {
    (void)_init;
  }

  explicit AddMarkerObservations_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : observation(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _observation_type =
    multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator>;
  _observation_type observation;

  // setters for named parameter idiom
  Type & set__observation(
    const multisensor_calibration_interface::msg::MarkerObservations_<ContainerAllocator> & _arg)
  {
    this->observation = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__multisensor_calibration_interface__srv__AddMarkerObservations_Request
    std::shared_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__multisensor_calibration_interface__srv__AddMarkerObservations_Request
    std::shared_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AddMarkerObservations_Request_ & other) const
  {
    if (this->observation != other.observation) {
      return false;
    }
    return true;
  }
  bool operator!=(const AddMarkerObservations_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AddMarkerObservations_Request_

// alias to use template instance with default allocator
using AddMarkerObservations_Request =
  multisensor_calibration_interface::srv::AddMarkerObservations_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace multisensor_calibration_interface


#ifndef _WIN32
# define DEPRECATED__multisensor_calibration_interface__srv__AddMarkerObservations_Response __attribute__((deprecated))
#else
# define DEPRECATED__multisensor_calibration_interface__srv__AddMarkerObservations_Response __declspec(deprecated)
#endif

namespace multisensor_calibration_interface
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct AddMarkerObservations_Response_
{
  using Type = AddMarkerObservations_Response_<ContainerAllocator>;

  explicit AddMarkerObservations_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_accepted = false;
      this->msg = "";
    }
  }

  explicit AddMarkerObservations_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : msg(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_accepted = false;
      this->msg = "";
    }
  }

  // field types and members
  using _is_accepted_type =
    bool;
  _is_accepted_type is_accepted;
  using _msg_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _msg_type msg;

  // setters for named parameter idiom
  Type & set__is_accepted(
    const bool & _arg)
  {
    this->is_accepted = _arg;
    return *this;
  }
  Type & set__msg(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->msg = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__multisensor_calibration_interface__srv__AddMarkerObservations_Response
    std::shared_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__multisensor_calibration_interface__srv__AddMarkerObservations_Response
    std::shared_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AddMarkerObservations_Response_ & other) const
  {
    if (this->is_accepted != other.is_accepted) {
      return false;
    }
    if (this->msg != other.msg) {
      return false;
    }
    return true;
  }
  bool operator!=(const AddMarkerObservations_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AddMarkerObservations_Response_

// alias to use template instance with default allocator
using AddMarkerObservations_Response =
  multisensor_calibration_interface::srv::AddMarkerObservations_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace multisensor_calibration_interface


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__multisensor_calibration_interface__srv__AddMarkerObservations_Event __attribute__((deprecated))
#else
# define DEPRECATED__multisensor_calibration_interface__srv__AddMarkerObservations_Event __declspec(deprecated)
#endif

namespace multisensor_calibration_interface
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct AddMarkerObservations_Event_
{
  using Type = AddMarkerObservations_Event_<ContainerAllocator>;

  explicit AddMarkerObservations_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit AddMarkerObservations_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<multisensor_calibration_interface::srv::AddMarkerObservations_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<multisensor_calibration_interface::srv::AddMarkerObservations_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    multisensor_calibration_interface::srv::AddMarkerObservations_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const multisensor_calibration_interface::srv::AddMarkerObservations_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::AddMarkerObservations_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::AddMarkerObservations_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__multisensor_calibration_interface__srv__AddMarkerObservations_Event
    std::shared_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__multisensor_calibration_interface__srv__AddMarkerObservations_Event
    std::shared_ptr<multisensor_calibration_interface::srv::AddMarkerObservations_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AddMarkerObservations_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const AddMarkerObservations_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AddMarkerObservations_Event_

// alias to use template instance with default allocator
using AddMarkerObservations_Event =
  multisensor_calibration_interface::srv::AddMarkerObservations_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace multisensor_calibration_interface

namespace multisensor_calibration_interface
{

namespace srv
{

struct AddMarkerObservations
{
  using Request = multisensor_calibration_interface::srv::AddMarkerObservations_Request;
  using Response = multisensor_calibration_interface::srv::AddMarkerObservations_Response;
  using Event = multisensor_calibration_interface::srv::AddMarkerObservations_Event;
};

}  // namespace srv

}  // namespace multisensor_calibration_interface

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__ADD_MARKER_OBSERVATIONS__STRUCT_HPP_
