// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from multisensor_calibration_interface:srv/CalibrationMetaData.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/srv/calibration_meta_data.h"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CALIBRATION_META_DATA__STRUCT_H_
#define MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CALIBRATION_META_DATA__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in srv/CalibrationMetaData in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__CalibrationMetaData_Request
{
  uint8_t structure_needs_at_least_one_member;
} multisensor_calibration_interface__srv__CalibrationMetaData_Request;

// Struct for a sequence of multisensor_calibration_interface__srv__CalibrationMetaData_Request.
typedef struct multisensor_calibration_interface__srv__CalibrationMetaData_Request__Sequence
{
  multisensor_calibration_interface__srv__CalibrationMetaData_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__CalibrationMetaData_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'robot_ws_path'
// Member 'calib_ws_path'
// Member 'calib_target_file_path'
// Member 'src_sensor_name'
// Member 'src_topic_name'
// Member 'src_frame_id'
// Member 'ref_sensor_name'
// Member 'ref_topic_name'
// Member 'ref_frame_id'
// Member 'base_frame_id'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/CalibrationMetaData in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__CalibrationMetaData_Response
{
  int32_t calib_type;
  /// path to robot workspace
  rosidl_runtime_c__String robot_ws_path;
  /// path to calibration workspace
  rosidl_runtime_c__String calib_ws_path;
  /// path to config file of calibration target
  rosidl_runtime_c__String calib_target_file_path;
  /// Name of source sensor
  rosidl_runtime_c__String src_sensor_name;
  /// Topic name of data source sensor
  rosidl_runtime_c__String src_topic_name;
  /// Frame ID of data source sensor
  rosidl_runtime_c__String src_frame_id;
  /// Name of reference sensor
  rosidl_runtime_c__String ref_sensor_name;
  /// Topic name of data reference sensor
  rosidl_runtime_c__String ref_topic_name;
  /// Frame ID of data reference sensor
  rosidl_runtime_c__String ref_frame_id;
  /// Frame ID of base frame with respect to which the calibration is to be done
  rosidl_runtime_c__String base_frame_id;
  /// Flag indicating if list is complete and, thus, if all meta data is available
  bool is_complete;
} multisensor_calibration_interface__srv__CalibrationMetaData_Response;

// Struct for a sequence of multisensor_calibration_interface__srv__CalibrationMetaData_Response.
typedef struct multisensor_calibration_interface__srv__CalibrationMetaData_Response__Sequence
{
  multisensor_calibration_interface__srv__CalibrationMetaData_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__CalibrationMetaData_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  multisensor_calibration_interface__srv__CalibrationMetaData_Event__request__MAX_SIZE = 1
};
// response
enum
{
  multisensor_calibration_interface__srv__CalibrationMetaData_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/CalibrationMetaData in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__CalibrationMetaData_Event
{
  service_msgs__msg__ServiceEventInfo info;
  multisensor_calibration_interface__srv__CalibrationMetaData_Request__Sequence request;
  multisensor_calibration_interface__srv__CalibrationMetaData_Response__Sequence response;
} multisensor_calibration_interface__srv__CalibrationMetaData_Event;

// Struct for a sequence of multisensor_calibration_interface__srv__CalibrationMetaData_Event.
typedef struct multisensor_calibration_interface__srv__CalibrationMetaData_Event__Sequence
{
  multisensor_calibration_interface__srv__CalibrationMetaData_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__CalibrationMetaData_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CALIBRATION_META_DATA__STRUCT_H_
