// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from multisensor_calibration_interface:srv/DataProcessorState.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/srv/data_processor_state.h"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__DATA_PROCESSOR_STATE__STRUCT_H_
#define MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__DATA_PROCESSOR_STATE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in srv/DataProcessorState in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__DataProcessorState_Request
{
  uint8_t structure_needs_at_least_one_member;
} multisensor_calibration_interface__srv__DataProcessorState_Request;

// Struct for a sequence of multisensor_calibration_interface__srv__DataProcessorState_Request.
typedef struct multisensor_calibration_interface__srv__DataProcessorState_Request__Sequence
{
  multisensor_calibration_interface__srv__DataProcessorState_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__DataProcessorState_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'frame_id'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/DataProcessorState in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__DataProcessorState_Response
{
  bool is_initialized;
  /// Frame id of data it processes
  rosidl_runtime_c__String frame_id;
} multisensor_calibration_interface__srv__DataProcessorState_Response;

// Struct for a sequence of multisensor_calibration_interface__srv__DataProcessorState_Response.
typedef struct multisensor_calibration_interface__srv__DataProcessorState_Response__Sequence
{
  multisensor_calibration_interface__srv__DataProcessorState_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__DataProcessorState_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  multisensor_calibration_interface__srv__DataProcessorState_Event__request__MAX_SIZE = 1
};
// response
enum
{
  multisensor_calibration_interface__srv__DataProcessorState_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/DataProcessorState in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__DataProcessorState_Event
{
  service_msgs__msg__ServiceEventInfo info;
  multisensor_calibration_interface__srv__DataProcessorState_Request__Sequence request;
  multisensor_calibration_interface__srv__DataProcessorState_Response__Sequence response;
} multisensor_calibration_interface__srv__DataProcessorState_Event;

// Struct for a sequence of multisensor_calibration_interface__srv__DataProcessorState_Event.
typedef struct multisensor_calibration_interface__srv__DataProcessorState_Event__Sequence
{
  multisensor_calibration_interface__srv__DataProcessorState_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__DataProcessorState_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__DATA_PROCESSOR_STATE__STRUCT_H_
