// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from multisensor_calibration_interface:srv/DataProcessorState.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/srv/data_processor_state.hpp"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__DATA_PROCESSOR_STATE__STRUCT_HPP_
#define MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__DATA_PROCESSOR_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__multisensor_calibration_interface__srv__DataProcessorState_Request __attribute__((deprecated))
#else
# define DEPRECATED__multisensor_calibration_interface__srv__DataProcessorState_Request __declspec(deprecated)
#endif

namespace multisensor_calibration_interface
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DataProcessorState_Request_
{
  using Type = DataProcessorState_Request_<ContainerAllocator>;

  explicit DataProcessorState_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit DataProcessorState_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__multisensor_calibration_interface__srv__DataProcessorState_Request
    std::shared_ptr<multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__multisensor_calibration_interface__srv__DataProcessorState_Request
    std::shared_ptr<multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DataProcessorState_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const DataProcessorState_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DataProcessorState_Request_

// alias to use template instance with default allocator
using DataProcessorState_Request =
  multisensor_calibration_interface::srv::DataProcessorState_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace multisensor_calibration_interface


#ifndef _WIN32
# define DEPRECATED__multisensor_calibration_interface__srv__DataProcessorState_Response __attribute__((deprecated))
#else
# define DEPRECATED__multisensor_calibration_interface__srv__DataProcessorState_Response __declspec(deprecated)
#endif

namespace multisensor_calibration_interface
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DataProcessorState_Response_
{
  using Type = DataProcessorState_Response_<ContainerAllocator>;

  explicit DataProcessorState_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_initialized = false;
      this->frame_id = "";
    }
  }

  explicit DataProcessorState_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : frame_id(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_initialized = false;
      this->frame_id = "";
    }
  }

  // field types and members
  using _is_initialized_type =
    bool;
  _is_initialized_type is_initialized;
  using _frame_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _frame_id_type frame_id;

  // setters for named parameter idiom
  Type & set__is_initialized(
    const bool & _arg)
  {
    this->is_initialized = _arg;
    return *this;
  }
  Type & set__frame_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->frame_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__multisensor_calibration_interface__srv__DataProcessorState_Response
    std::shared_ptr<multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__multisensor_calibration_interface__srv__DataProcessorState_Response
    std::shared_ptr<multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DataProcessorState_Response_ & other) const
  {
    if (this->is_initialized != other.is_initialized) {
      return false;
    }
    if (this->frame_id != other.frame_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const DataProcessorState_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DataProcessorState_Response_

// alias to use template instance with default allocator
using DataProcessorState_Response =
  multisensor_calibration_interface::srv::DataProcessorState_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace multisensor_calibration_interface


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__multisensor_calibration_interface__srv__DataProcessorState_Event __attribute__((deprecated))
#else
# define DEPRECATED__multisensor_calibration_interface__srv__DataProcessorState_Event __declspec(deprecated)
#endif

namespace multisensor_calibration_interface
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DataProcessorState_Event_
{
  using Type = DataProcessorState_Event_<ContainerAllocator>;

  explicit DataProcessorState_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit DataProcessorState_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<multisensor_calibration_interface::srv::DataProcessorState_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<multisensor_calibration_interface::srv::DataProcessorState_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    multisensor_calibration_interface::srv::DataProcessorState_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const multisensor_calibration_interface::srv::DataProcessorState_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::DataProcessorState_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::DataProcessorState_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::DataProcessorState_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::DataProcessorState_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::DataProcessorState_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::DataProcessorState_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::DataProcessorState_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::DataProcessorState_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__multisensor_calibration_interface__srv__DataProcessorState_Event
    std::shared_ptr<multisensor_calibration_interface::srv::DataProcessorState_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__multisensor_calibration_interface__srv__DataProcessorState_Event
    std::shared_ptr<multisensor_calibration_interface::srv::DataProcessorState_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DataProcessorState_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const DataProcessorState_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DataProcessorState_Event_

// alias to use template instance with default allocator
using DataProcessorState_Event =
  multisensor_calibration_interface::srv::DataProcessorState_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace multisensor_calibration_interface

namespace multisensor_calibration_interface
{

namespace srv
{

struct DataProcessorState
{
  using Request = multisensor_calibration_interface::srv::DataProcessorState_Request;
  using Response = multisensor_calibration_interface::srv::DataProcessorState_Response;
  using Event = multisensor_calibration_interface::srv::DataProcessorState_Event;
};

}  // namespace srv

}  // namespace multisensor_calibration_interface

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__DATA_PROCESSOR_STATE__STRUCT_HPP_
