// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from multisensor_calibration_interface:srv/ImportMarkerObservations.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/srv/import_marker_observations.hpp"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__IMPORT_MARKER_OBSERVATIONS__TRAITS_HPP_
#define MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__IMPORT_MARKER_OBSERVATIONS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "multisensor_calibration_interface/srv/detail/import_marker_observations__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'observation_list'
#include "multisensor_calibration_interface/msg/detail/marker_observations__traits.hpp"

namespace multisensor_calibration_interface
{

namespace srv
{

inline void to_flow_style_yaml(
  const ImportMarkerObservations_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: observation_list
  {
    if (msg.observation_list.size() == 0) {
      out << "observation_list: []";
    } else {
      out << "observation_list: [";
      size_t pending_items = msg.observation_list.size();
      for (auto item : msg.observation_list) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ImportMarkerObservations_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: observation_list
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.observation_list.size() == 0) {
      out << "observation_list: []\n";
    } else {
      out << "observation_list:\n";
      for (auto item : msg.observation_list) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ImportMarkerObservations_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace multisensor_calibration_interface

namespace rosidl_generator_traits
{

[[deprecated("use multisensor_calibration_interface::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const multisensor_calibration_interface::srv::ImportMarkerObservations_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  multisensor_calibration_interface::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use multisensor_calibration_interface::srv::to_yaml() instead")]]
inline std::string to_yaml(const multisensor_calibration_interface::srv::ImportMarkerObservations_Request & msg)
{
  return multisensor_calibration_interface::srv::to_yaml(msg);
}

template<>
inline const char * data_type<multisensor_calibration_interface::srv::ImportMarkerObservations_Request>()
{
  return "multisensor_calibration_interface::srv::ImportMarkerObservations_Request";
}

template<>
inline const char * name<multisensor_calibration_interface::srv::ImportMarkerObservations_Request>()
{
  return "multisensor_calibration_interface/srv/ImportMarkerObservations_Request";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::srv::ImportMarkerObservations_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<multisensor_calibration_interface::srv::ImportMarkerObservations_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<multisensor_calibration_interface::srv::ImportMarkerObservations_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace multisensor_calibration_interface
{

namespace srv
{

inline void to_flow_style_yaml(
  const ImportMarkerObservations_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: is_accepted
  {
    out << "is_accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.is_accepted, out);
    out << ", ";
  }

  // member: msg
  {
    out << "msg: ";
    rosidl_generator_traits::value_to_yaml(msg.msg, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ImportMarkerObservations_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: is_accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.is_accepted, out);
    out << "\n";
  }

  // member: msg
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "msg: ";
    rosidl_generator_traits::value_to_yaml(msg.msg, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ImportMarkerObservations_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace multisensor_calibration_interface

namespace rosidl_generator_traits
{

[[deprecated("use multisensor_calibration_interface::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const multisensor_calibration_interface::srv::ImportMarkerObservations_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  multisensor_calibration_interface::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use multisensor_calibration_interface::srv::to_yaml() instead")]]
inline std::string to_yaml(const multisensor_calibration_interface::srv::ImportMarkerObservations_Response & msg)
{
  return multisensor_calibration_interface::srv::to_yaml(msg);
}

template<>
inline const char * data_type<multisensor_calibration_interface::srv::ImportMarkerObservations_Response>()
{
  return "multisensor_calibration_interface::srv::ImportMarkerObservations_Response";
}

template<>
inline const char * name<multisensor_calibration_interface::srv::ImportMarkerObservations_Response>()
{
  return "multisensor_calibration_interface/srv/ImportMarkerObservations_Response";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::srv::ImportMarkerObservations_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<multisensor_calibration_interface::srv::ImportMarkerObservations_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<multisensor_calibration_interface::srv::ImportMarkerObservations_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace multisensor_calibration_interface
{

namespace srv
{

inline void to_flow_style_yaml(
  const ImportMarkerObservations_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ImportMarkerObservations_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ImportMarkerObservations_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace multisensor_calibration_interface

namespace rosidl_generator_traits
{

[[deprecated("use multisensor_calibration_interface::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const multisensor_calibration_interface::srv::ImportMarkerObservations_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  multisensor_calibration_interface::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use multisensor_calibration_interface::srv::to_yaml() instead")]]
inline std::string to_yaml(const multisensor_calibration_interface::srv::ImportMarkerObservations_Event & msg)
{
  return multisensor_calibration_interface::srv::to_yaml(msg);
}

template<>
inline const char * data_type<multisensor_calibration_interface::srv::ImportMarkerObservations_Event>()
{
  return "multisensor_calibration_interface::srv::ImportMarkerObservations_Event";
}

template<>
inline const char * name<multisensor_calibration_interface::srv::ImportMarkerObservations_Event>()
{
  return "multisensor_calibration_interface/srv/ImportMarkerObservations_Event";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::srv::ImportMarkerObservations_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<multisensor_calibration_interface::srv::ImportMarkerObservations_Event>
  : std::integral_constant<bool, has_bounded_size<multisensor_calibration_interface::srv::ImportMarkerObservations_Request>::value && has_bounded_size<multisensor_calibration_interface::srv::ImportMarkerObservations_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<multisensor_calibration_interface::srv::ImportMarkerObservations_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<multisensor_calibration_interface::srv::ImportMarkerObservations>()
{
  return "multisensor_calibration_interface::srv::ImportMarkerObservations";
}

template<>
inline const char * name<multisensor_calibration_interface::srv::ImportMarkerObservations>()
{
  return "multisensor_calibration_interface/srv/ImportMarkerObservations";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::srv::ImportMarkerObservations>
  : std::integral_constant<
    bool,
    has_fixed_size<multisensor_calibration_interface::srv::ImportMarkerObservations_Request>::value &&
    has_fixed_size<multisensor_calibration_interface::srv::ImportMarkerObservations_Response>::value
  >
{
};

template<>
struct has_bounded_size<multisensor_calibration_interface::srv::ImportMarkerObservations>
  : std::integral_constant<
    bool,
    has_bounded_size<multisensor_calibration_interface::srv::ImportMarkerObservations_Request>::value &&
    has_bounded_size<multisensor_calibration_interface::srv::ImportMarkerObservations_Response>::value
  >
{
};

template<>
struct is_service<multisensor_calibration_interface::srv::ImportMarkerObservations>
  : std::true_type
{
};

template<>
struct is_service_request<multisensor_calibration_interface::srv::ImportMarkerObservations_Request>
  : std::true_type
{
};

template<>
struct is_service_response<multisensor_calibration_interface::srv::ImportMarkerObservations_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__IMPORT_MARKER_OBSERVATIONS__TRAITS_HPP_
