// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from multisensor_calibration_interface:srv/SensorExtrinsics.idl
// generated code does not contain a copyright notice
#include "multisensor_calibration_interface/srv/detail/sensor_extrinsics__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Request__init(multisensor_calibration_interface__srv__SensorExtrinsics_Request * msg)
{
  if (!msg) {
    return false;
  }
  // extrinsic_type
  return true;
}

void
multisensor_calibration_interface__srv__SensorExtrinsics_Request__fini(multisensor_calibration_interface__srv__SensorExtrinsics_Request * msg)
{
  if (!msg) {
    return;
  }
  // extrinsic_type
}

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Request__are_equal(const multisensor_calibration_interface__srv__SensorExtrinsics_Request * lhs, const multisensor_calibration_interface__srv__SensorExtrinsics_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // extrinsic_type
  if (lhs->extrinsic_type != rhs->extrinsic_type) {
    return false;
  }
  return true;
}

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Request__copy(
  const multisensor_calibration_interface__srv__SensorExtrinsics_Request * input,
  multisensor_calibration_interface__srv__SensorExtrinsics_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // extrinsic_type
  output->extrinsic_type = input->extrinsic_type;
  return true;
}

multisensor_calibration_interface__srv__SensorExtrinsics_Request *
multisensor_calibration_interface__srv__SensorExtrinsics_Request__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__srv__SensorExtrinsics_Request * msg = (multisensor_calibration_interface__srv__SensorExtrinsics_Request *)allocator.allocate(sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Request));
  bool success = multisensor_calibration_interface__srv__SensorExtrinsics_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
multisensor_calibration_interface__srv__SensorExtrinsics_Request__destroy(multisensor_calibration_interface__srv__SensorExtrinsics_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    multisensor_calibration_interface__srv__SensorExtrinsics_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence__init(multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__srv__SensorExtrinsics_Request * data = NULL;

  if (size) {
    data = (multisensor_calibration_interface__srv__SensorExtrinsics_Request *)allocator.zero_allocate(size, sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = multisensor_calibration_interface__srv__SensorExtrinsics_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        multisensor_calibration_interface__srv__SensorExtrinsics_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence__fini(multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      multisensor_calibration_interface__srv__SensorExtrinsics_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence *
multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence * array = (multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence *)allocator.allocate(sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence__destroy(multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence__are_equal(const multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence * lhs, const multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!multisensor_calibration_interface__srv__SensorExtrinsics_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence__copy(
  const multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence * input,
  multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    multisensor_calibration_interface__srv__SensorExtrinsics_Request * data =
      (multisensor_calibration_interface__srv__SensorExtrinsics_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!multisensor_calibration_interface__srv__SensorExtrinsics_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          multisensor_calibration_interface__srv__SensorExtrinsics_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!multisensor_calibration_interface__srv__SensorExtrinsics_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `extrinsics`
#include "geometry_msgs/msg/detail/pose__functions.h"

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Response__init(multisensor_calibration_interface__srv__SensorExtrinsics_Response * msg)
{
  if (!msg) {
    return false;
  }
  // extrinsics
  if (!geometry_msgs__msg__Pose__init(&msg->extrinsics)) {
    multisensor_calibration_interface__srv__SensorExtrinsics_Response__fini(msg);
    return false;
  }
  return true;
}

void
multisensor_calibration_interface__srv__SensorExtrinsics_Response__fini(multisensor_calibration_interface__srv__SensorExtrinsics_Response * msg)
{
  if (!msg) {
    return;
  }
  // extrinsics
  geometry_msgs__msg__Pose__fini(&msg->extrinsics);
}

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Response__are_equal(const multisensor_calibration_interface__srv__SensorExtrinsics_Response * lhs, const multisensor_calibration_interface__srv__SensorExtrinsics_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // extrinsics
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->extrinsics), &(rhs->extrinsics)))
  {
    return false;
  }
  return true;
}

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Response__copy(
  const multisensor_calibration_interface__srv__SensorExtrinsics_Response * input,
  multisensor_calibration_interface__srv__SensorExtrinsics_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // extrinsics
  if (!geometry_msgs__msg__Pose__copy(
      &(input->extrinsics), &(output->extrinsics)))
  {
    return false;
  }
  return true;
}

multisensor_calibration_interface__srv__SensorExtrinsics_Response *
multisensor_calibration_interface__srv__SensorExtrinsics_Response__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__srv__SensorExtrinsics_Response * msg = (multisensor_calibration_interface__srv__SensorExtrinsics_Response *)allocator.allocate(sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Response));
  bool success = multisensor_calibration_interface__srv__SensorExtrinsics_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
multisensor_calibration_interface__srv__SensorExtrinsics_Response__destroy(multisensor_calibration_interface__srv__SensorExtrinsics_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    multisensor_calibration_interface__srv__SensorExtrinsics_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence__init(multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__srv__SensorExtrinsics_Response * data = NULL;

  if (size) {
    data = (multisensor_calibration_interface__srv__SensorExtrinsics_Response *)allocator.zero_allocate(size, sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = multisensor_calibration_interface__srv__SensorExtrinsics_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        multisensor_calibration_interface__srv__SensorExtrinsics_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence__fini(multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      multisensor_calibration_interface__srv__SensorExtrinsics_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence *
multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence * array = (multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence *)allocator.allocate(sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence__destroy(multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence__are_equal(const multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence * lhs, const multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!multisensor_calibration_interface__srv__SensorExtrinsics_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence__copy(
  const multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence * input,
  multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    multisensor_calibration_interface__srv__SensorExtrinsics_Response * data =
      (multisensor_calibration_interface__srv__SensorExtrinsics_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!multisensor_calibration_interface__srv__SensorExtrinsics_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          multisensor_calibration_interface__srv__SensorExtrinsics_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!multisensor_calibration_interface__srv__SensorExtrinsics_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `info`
#include "service_msgs/msg/detail/service_event_info__functions.h"
// Member `request`
// Member `response`
// already included above
// #include "multisensor_calibration_interface/srv/detail/sensor_extrinsics__functions.h"

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Event__init(multisensor_calibration_interface__srv__SensorExtrinsics_Event * msg)
{
  if (!msg) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__init(&msg->info)) {
    multisensor_calibration_interface__srv__SensorExtrinsics_Event__fini(msg);
    return false;
  }
  // request
  if (!multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence__init(&msg->request, 0)) {
    multisensor_calibration_interface__srv__SensorExtrinsics_Event__fini(msg);
    return false;
  }
  // response
  if (!multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence__init(&msg->response, 0)) {
    multisensor_calibration_interface__srv__SensorExtrinsics_Event__fini(msg);
    return false;
  }
  return true;
}

void
multisensor_calibration_interface__srv__SensorExtrinsics_Event__fini(multisensor_calibration_interface__srv__SensorExtrinsics_Event * msg)
{
  if (!msg) {
    return;
  }
  // info
  service_msgs__msg__ServiceEventInfo__fini(&msg->info);
  // request
  multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence__fini(&msg->request);
  // response
  multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence__fini(&msg->response);
}

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Event__are_equal(const multisensor_calibration_interface__srv__SensorExtrinsics_Event * lhs, const multisensor_calibration_interface__srv__SensorExtrinsics_Event * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  // request
  if (!multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence__are_equal(
      &(lhs->request), &(rhs->request)))
  {
    return false;
  }
  // response
  if (!multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence__are_equal(
      &(lhs->response), &(rhs->response)))
  {
    return false;
  }
  return true;
}

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Event__copy(
  const multisensor_calibration_interface__srv__SensorExtrinsics_Event * input,
  multisensor_calibration_interface__srv__SensorExtrinsics_Event * output)
{
  if (!input || !output) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  // request
  if (!multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence__copy(
      &(input->request), &(output->request)))
  {
    return false;
  }
  // response
  if (!multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence__copy(
      &(input->response), &(output->response)))
  {
    return false;
  }
  return true;
}

multisensor_calibration_interface__srv__SensorExtrinsics_Event *
multisensor_calibration_interface__srv__SensorExtrinsics_Event__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__srv__SensorExtrinsics_Event * msg = (multisensor_calibration_interface__srv__SensorExtrinsics_Event *)allocator.allocate(sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Event), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Event));
  bool success = multisensor_calibration_interface__srv__SensorExtrinsics_Event__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
multisensor_calibration_interface__srv__SensorExtrinsics_Event__destroy(multisensor_calibration_interface__srv__SensorExtrinsics_Event * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    multisensor_calibration_interface__srv__SensorExtrinsics_Event__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence__init(multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__srv__SensorExtrinsics_Event * data = NULL;

  if (size) {
    data = (multisensor_calibration_interface__srv__SensorExtrinsics_Event *)allocator.zero_allocate(size, sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Event), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = multisensor_calibration_interface__srv__SensorExtrinsics_Event__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        multisensor_calibration_interface__srv__SensorExtrinsics_Event__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence__fini(multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      multisensor_calibration_interface__srv__SensorExtrinsics_Event__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence *
multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence * array = (multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence *)allocator.allocate(sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence__destroy(multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence__are_equal(const multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence * lhs, const multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!multisensor_calibration_interface__srv__SensorExtrinsics_Event__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence__copy(
  const multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence * input,
  multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(multisensor_calibration_interface__srv__SensorExtrinsics_Event);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    multisensor_calibration_interface__srv__SensorExtrinsics_Event * data =
      (multisensor_calibration_interface__srv__SensorExtrinsics_Event *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!multisensor_calibration_interface__srv__SensorExtrinsics_Event__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          multisensor_calibration_interface__srv__SensorExtrinsics_Event__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!multisensor_calibration_interface__srv__SensorExtrinsics_Event__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
