// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from multisensor_calibration_interface:msg/CalibrationResult.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/msg/calibration_result.hpp"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__CALIBRATION_RESULT__STRUCT_HPP_
#define MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__CALIBRATION_RESULT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'sensor_extrinsics'
#include "geometry_msgs/msg/detail/transform__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__multisensor_calibration_interface__msg__CalibrationResult __attribute__((deprecated))
#else
# define DEPRECATED__multisensor_calibration_interface__msg__CalibrationResult __declspec(deprecated)
#endif

namespace multisensor_calibration_interface
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CalibrationResult_
{
  using Type = CalibrationResult_<ContainerAllocator>;

  explicit CalibrationResult_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : sensor_extrinsics(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_successful = false;
      this->src_frame_id = "";
      this->ref_frame_id = "";
      this->base_frame_id = "";
    }
  }

  explicit CalibrationResult_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : src_frame_id(_alloc),
    ref_frame_id(_alloc),
    base_frame_id(_alloc),
    sensor_extrinsics(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->is_successful = false;
      this->src_frame_id = "";
      this->ref_frame_id = "";
      this->base_frame_id = "";
    }
  }

  // field types and members
  using _is_successful_type =
    bool;
  _is_successful_type is_successful;
  using _src_frame_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _src_frame_id_type src_frame_id;
  using _ref_frame_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _ref_frame_id_type ref_frame_id;
  using _base_frame_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _base_frame_id_type base_frame_id;
  using _sensor_extrinsics_type =
    geometry_msgs::msg::Transform_<ContainerAllocator>;
  _sensor_extrinsics_type sensor_extrinsics;

  // setters for named parameter idiom
  Type & set__is_successful(
    const bool & _arg)
  {
    this->is_successful = _arg;
    return *this;
  }
  Type & set__src_frame_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->src_frame_id = _arg;
    return *this;
  }
  Type & set__ref_frame_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->ref_frame_id = _arg;
    return *this;
  }
  Type & set__base_frame_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->base_frame_id = _arg;
    return *this;
  }
  Type & set__sensor_extrinsics(
    const geometry_msgs::msg::Transform_<ContainerAllocator> & _arg)
  {
    this->sensor_extrinsics = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    multisensor_calibration_interface::msg::CalibrationResult_<ContainerAllocator> *;
  using ConstRawPtr =
    const multisensor_calibration_interface::msg::CalibrationResult_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<multisensor_calibration_interface::msg::CalibrationResult_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<multisensor_calibration_interface::msg::CalibrationResult_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::msg::CalibrationResult_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::msg::CalibrationResult_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::msg::CalibrationResult_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::msg::CalibrationResult_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<multisensor_calibration_interface::msg::CalibrationResult_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<multisensor_calibration_interface::msg::CalibrationResult_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__multisensor_calibration_interface__msg__CalibrationResult
    std::shared_ptr<multisensor_calibration_interface::msg::CalibrationResult_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__multisensor_calibration_interface__msg__CalibrationResult
    std::shared_ptr<multisensor_calibration_interface::msg::CalibrationResult_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CalibrationResult_ & other) const
  {
    if (this->is_successful != other.is_successful) {
      return false;
    }
    if (this->src_frame_id != other.src_frame_id) {
      return false;
    }
    if (this->ref_frame_id != other.ref_frame_id) {
      return false;
    }
    if (this->base_frame_id != other.base_frame_id) {
      return false;
    }
    if (this->sensor_extrinsics != other.sensor_extrinsics) {
      return false;
    }
    return true;
  }
  bool operator!=(const CalibrationResult_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CalibrationResult_

// alias to use template instance with default allocator
using CalibrationResult =
  multisensor_calibration_interface::msg::CalibrationResult_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace multisensor_calibration_interface

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__CALIBRATION_RESULT__STRUCT_HPP_
