// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from multisensor_calibration_interface:msg/MarkerObservations.idl
// generated code does not contain a copyright notice

#include "multisensor_calibration_interface/msg/detail/marker_observations__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
const rosidl_type_hash_t *
multisensor_calibration_interface__msg__MarkerObservations__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x14, 0xec, 0x84, 0x23, 0x37, 0x14, 0x33, 0x69,
      0xee, 0x4e, 0xaa, 0x36, 0xf2, 0x8d, 0x27, 0x15,
      0x4f, 0xba, 0x8f, 0x83, 0x48, 0xb9, 0x65, 0xaa,
      0x63, 0x76, 0x3b, 0x47, 0xa5, 0xdd, 0xe0, 0x5e,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "geometry_msgs/msg/detail/point__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t geometry_msgs__msg__Point__EXPECTED_HASH = {1, {
    0x69, 0x63, 0x08, 0x48, 0x42, 0xa9, 0xb0, 0x44,
    0x94, 0xd6, 0xb2, 0x94, 0x1d, 0x11, 0x44, 0x47,
    0x08, 0xd8, 0x92, 0xda, 0x2f, 0x4b, 0x09, 0x84,
    0x3b, 0x9c, 0x43, 0xf4, 0x2a, 0x7f, 0x68, 0x81,
  }};
#endif

static char multisensor_calibration_interface__msg__MarkerObservations__TYPE_NAME[] = "multisensor_calibration_interface/msg/MarkerObservations";
static char geometry_msgs__msg__Point__TYPE_NAME[] = "geometry_msgs/msg/Point";

// Define type names, field names, and default values
static char multisensor_calibration_interface__msg__MarkerObservations__FIELD_NAME__marker_ids[] = "marker_ids";
static char multisensor_calibration_interface__msg__MarkerObservations__FIELD_NAME__marker_top_left_point[] = "marker_top_left_point";

static rosidl_runtime_c__type_description__Field multisensor_calibration_interface__msg__MarkerObservations__FIELDS[] = {
  {
    {multisensor_calibration_interface__msg__MarkerObservations__FIELD_NAME__marker_ids, 10, 10},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT32_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {multisensor_calibration_interface__msg__MarkerObservations__FIELD_NAME__marker_top_left_point, 21, 21},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE_UNBOUNDED_SEQUENCE,
      0,
      0,
      {geometry_msgs__msg__Point__TYPE_NAME, 23, 23},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription multisensor_calibration_interface__msg__MarkerObservations__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {geometry_msgs__msg__Point__TYPE_NAME, 23, 23},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
multisensor_calibration_interface__msg__MarkerObservations__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {multisensor_calibration_interface__msg__MarkerObservations__TYPE_NAME, 56, 56},
      {multisensor_calibration_interface__msg__MarkerObservations__FIELDS, 2, 2},
    },
    {multisensor_calibration_interface__msg__MarkerObservations__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&geometry_msgs__msg__Point__EXPECTED_HASH, geometry_msgs__msg__Point__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = geometry_msgs__msg__Point__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "########################################################################\n"
  "#\n"
  "#   Copyright (c) 2022 - 2024 Fraunhofer Institute of Optronics,\n"
  "#   System Technologies and Image Exploitation IOSB\n"
  "#\n"
  "########################################################################\n"
  "\n"
  "# IDs of markers for which to add the reference points\n"
  "uint32[] marker_ids\n"
  "\n"
  "# Position of the top-left corner. In case of 2D observations (i.e. image points) only \n"
  "# x and y coordinates are used.\n"
  "geometry_msgs/Point[] marker_top_left_point";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
multisensor_calibration_interface__msg__MarkerObservations__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {multisensor_calibration_interface__msg__MarkerObservations__TYPE_NAME, 56, 56},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 507, 507},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
multisensor_calibration_interface__msg__MarkerObservations__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *multisensor_calibration_interface__msg__MarkerObservations__get_individual_type_description_source(NULL),
    sources[1] = *geometry_msgs__msg__Point__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
