// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from multisensor_calibration_interface:msg/StampedFloat32MultiArray.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/msg/stamped_float32_multi_array.h"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__STAMPED_FLOAT32_MULTI_ARRAY__FUNCTIONS_H_
#define MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__STAMPED_FLOAT32_MULTI_ARRAY__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "multisensor_calibration_interface/msg/rosidl_generator_c__visibility_control.h"

#include "multisensor_calibration_interface/msg/detail/stamped_float32_multi_array__struct.h"

/// Initialize msg/StampedFloat32MultiArray message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * multisensor_calibration_interface__msg__StampedFloat32MultiArray
 * )) before or use
 * multisensor_calibration_interface__msg__StampedFloat32MultiArray__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
bool
multisensor_calibration_interface__msg__StampedFloat32MultiArray__init(multisensor_calibration_interface__msg__StampedFloat32MultiArray * msg);

/// Finalize msg/StampedFloat32MultiArray message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
void
multisensor_calibration_interface__msg__StampedFloat32MultiArray__fini(multisensor_calibration_interface__msg__StampedFloat32MultiArray * msg);

/// Create msg/StampedFloat32MultiArray message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * multisensor_calibration_interface__msg__StampedFloat32MultiArray__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
multisensor_calibration_interface__msg__StampedFloat32MultiArray *
multisensor_calibration_interface__msg__StampedFloat32MultiArray__create(void);

/// Destroy msg/StampedFloat32MultiArray message.
/**
 * It calls
 * multisensor_calibration_interface__msg__StampedFloat32MultiArray__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
void
multisensor_calibration_interface__msg__StampedFloat32MultiArray__destroy(multisensor_calibration_interface__msg__StampedFloat32MultiArray * msg);

/// Check for msg/StampedFloat32MultiArray message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
bool
multisensor_calibration_interface__msg__StampedFloat32MultiArray__are_equal(const multisensor_calibration_interface__msg__StampedFloat32MultiArray * lhs, const multisensor_calibration_interface__msg__StampedFloat32MultiArray * rhs);

/// Copy a msg/StampedFloat32MultiArray message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
bool
multisensor_calibration_interface__msg__StampedFloat32MultiArray__copy(
  const multisensor_calibration_interface__msg__StampedFloat32MultiArray * input,
  multisensor_calibration_interface__msg__StampedFloat32MultiArray * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
const rosidl_type_hash_t *
multisensor_calibration_interface__msg__StampedFloat32MultiArray__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
const rosidl_runtime_c__type_description__TypeDescription *
multisensor_calibration_interface__msg__StampedFloat32MultiArray__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
const rosidl_runtime_c__type_description__TypeSource *
multisensor_calibration_interface__msg__StampedFloat32MultiArray__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
const rosidl_runtime_c__type_description__TypeSource__Sequence *
multisensor_calibration_interface__msg__StampedFloat32MultiArray__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/StampedFloat32MultiArray messages.
/**
 * It allocates the memory for the number of elements and calls
 * multisensor_calibration_interface__msg__StampedFloat32MultiArray__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
bool
multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__init(multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * array, size_t size);

/// Finalize array of msg/StampedFloat32MultiArray messages.
/**
 * It calls
 * multisensor_calibration_interface__msg__StampedFloat32MultiArray__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
void
multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__fini(multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * array);

/// Create array of msg/StampedFloat32MultiArray messages.
/**
 * It allocates the memory for the array and calls
 * multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence *
multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__create(size_t size);

/// Destroy array of msg/StampedFloat32MultiArray messages.
/**
 * It calls
 * multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
void
multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__destroy(multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * array);

/// Check for msg/StampedFloat32MultiArray message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
bool
multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__are_equal(const multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * lhs, const multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * rhs);

/// Copy an array of msg/StampedFloat32MultiArray messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_multisensor_calibration_interface
bool
multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence__copy(
  const multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * input,
  multisensor_calibration_interface__msg__StampedFloat32MultiArray__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__MSG__DETAIL__STAMPED_FLOAT32_MULTI_ARRAY__FUNCTIONS_H_
