// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from multisensor_calibration_interface:srv/AddRegionMarker.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/srv/add_region_marker.h"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__ADD_REGION_MARKER__STRUCT_H_
#define MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__ADD_REGION_MARKER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'sensor_frame_id'
#include "rosidl_runtime_c/string.h"
// Member 'point'
#include "geometry_msgs/msg/detail/point__struct.h"

/// Struct defined in srv/AddRegionMarker in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__AddRegionMarker_Request
{
  /// Frame ID of sensor to which the region belongs.
  rosidl_runtime_c__String sensor_frame_id;
  /// Position of the marker as 3D point
  geometry_msgs__msg__Point point;
} multisensor_calibration_interface__srv__AddRegionMarker_Request;

// Struct for a sequence of multisensor_calibration_interface__srv__AddRegionMarker_Request.
typedef struct multisensor_calibration_interface__srv__AddRegionMarker_Request__Sequence
{
  multisensor_calibration_interface__srv__AddRegionMarker_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__AddRegionMarker_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'msg'
// already included above
// #include "rosidl_runtime_c/string.h"

/// Struct defined in srv/AddRegionMarker in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__AddRegionMarker_Response
{
  bool is_accepted;
  /// Response message
  rosidl_runtime_c__String msg;
} multisensor_calibration_interface__srv__AddRegionMarker_Response;

// Struct for a sequence of multisensor_calibration_interface__srv__AddRegionMarker_Response.
typedef struct multisensor_calibration_interface__srv__AddRegionMarker_Response__Sequence
{
  multisensor_calibration_interface__srv__AddRegionMarker_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__AddRegionMarker_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  multisensor_calibration_interface__srv__AddRegionMarker_Event__request__MAX_SIZE = 1
};
// response
enum
{
  multisensor_calibration_interface__srv__AddRegionMarker_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/AddRegionMarker in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__AddRegionMarker_Event
{
  service_msgs__msg__ServiceEventInfo info;
  multisensor_calibration_interface__srv__AddRegionMarker_Request__Sequence request;
  multisensor_calibration_interface__srv__AddRegionMarker_Response__Sequence response;
} multisensor_calibration_interface__srv__AddRegionMarker_Event;

// Struct for a sequence of multisensor_calibration_interface__srv__AddRegionMarker_Event.
typedef struct multisensor_calibration_interface__srv__AddRegionMarker_Event__Sequence
{
  multisensor_calibration_interface__srv__AddRegionMarker_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__AddRegionMarker_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__ADD_REGION_MARKER__STRUCT_H_
