// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from multisensor_calibration_interface:srv/CalibrationMetaData.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/srv/calibration_meta_data.hpp"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CALIBRATION_META_DATA__STRUCT_HPP_
#define MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CALIBRATION_META_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__multisensor_calibration_interface__srv__CalibrationMetaData_Request __attribute__((deprecated))
#else
# define DEPRECATED__multisensor_calibration_interface__srv__CalibrationMetaData_Request __declspec(deprecated)
#endif

namespace multisensor_calibration_interface
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct CalibrationMetaData_Request_
{
  using Type = CalibrationMetaData_Request_<ContainerAllocator>;

  explicit CalibrationMetaData_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit CalibrationMetaData_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__multisensor_calibration_interface__srv__CalibrationMetaData_Request
    std::shared_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__multisensor_calibration_interface__srv__CalibrationMetaData_Request
    std::shared_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CalibrationMetaData_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const CalibrationMetaData_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CalibrationMetaData_Request_

// alias to use template instance with default allocator
using CalibrationMetaData_Request =
  multisensor_calibration_interface::srv::CalibrationMetaData_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace multisensor_calibration_interface


#ifndef _WIN32
# define DEPRECATED__multisensor_calibration_interface__srv__CalibrationMetaData_Response __attribute__((deprecated))
#else
# define DEPRECATED__multisensor_calibration_interface__srv__CalibrationMetaData_Response __declspec(deprecated)
#endif

namespace multisensor_calibration_interface
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct CalibrationMetaData_Response_
{
  using Type = CalibrationMetaData_Response_<ContainerAllocator>;

  explicit CalibrationMetaData_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->calib_type = 0l;
      this->robot_ws_path = "";
      this->calib_ws_path = "";
      this->calib_target_file_path = "";
      this->src_sensor_name = "";
      this->src_topic_name = "";
      this->src_frame_id = "";
      this->ref_sensor_name = "";
      this->ref_topic_name = "";
      this->ref_frame_id = "";
      this->base_frame_id = "";
      this->is_complete = false;
    }
  }

  explicit CalibrationMetaData_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : robot_ws_path(_alloc),
    calib_ws_path(_alloc),
    calib_target_file_path(_alloc),
    src_sensor_name(_alloc),
    src_topic_name(_alloc),
    src_frame_id(_alloc),
    ref_sensor_name(_alloc),
    ref_topic_name(_alloc),
    ref_frame_id(_alloc),
    base_frame_id(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->calib_type = 0l;
      this->robot_ws_path = "";
      this->calib_ws_path = "";
      this->calib_target_file_path = "";
      this->src_sensor_name = "";
      this->src_topic_name = "";
      this->src_frame_id = "";
      this->ref_sensor_name = "";
      this->ref_topic_name = "";
      this->ref_frame_id = "";
      this->base_frame_id = "";
      this->is_complete = false;
    }
  }

  // field types and members
  using _calib_type_type =
    int32_t;
  _calib_type_type calib_type;
  using _robot_ws_path_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _robot_ws_path_type robot_ws_path;
  using _calib_ws_path_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _calib_ws_path_type calib_ws_path;
  using _calib_target_file_path_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _calib_target_file_path_type calib_target_file_path;
  using _src_sensor_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _src_sensor_name_type src_sensor_name;
  using _src_topic_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _src_topic_name_type src_topic_name;
  using _src_frame_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _src_frame_id_type src_frame_id;
  using _ref_sensor_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _ref_sensor_name_type ref_sensor_name;
  using _ref_topic_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _ref_topic_name_type ref_topic_name;
  using _ref_frame_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _ref_frame_id_type ref_frame_id;
  using _base_frame_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _base_frame_id_type base_frame_id;
  using _is_complete_type =
    bool;
  _is_complete_type is_complete;

  // setters for named parameter idiom
  Type & set__calib_type(
    const int32_t & _arg)
  {
    this->calib_type = _arg;
    return *this;
  }
  Type & set__robot_ws_path(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->robot_ws_path = _arg;
    return *this;
  }
  Type & set__calib_ws_path(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->calib_ws_path = _arg;
    return *this;
  }
  Type & set__calib_target_file_path(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->calib_target_file_path = _arg;
    return *this;
  }
  Type & set__src_sensor_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->src_sensor_name = _arg;
    return *this;
  }
  Type & set__src_topic_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->src_topic_name = _arg;
    return *this;
  }
  Type & set__src_frame_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->src_frame_id = _arg;
    return *this;
  }
  Type & set__ref_sensor_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->ref_sensor_name = _arg;
    return *this;
  }
  Type & set__ref_topic_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->ref_topic_name = _arg;
    return *this;
  }
  Type & set__ref_frame_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->ref_frame_id = _arg;
    return *this;
  }
  Type & set__base_frame_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->base_frame_id = _arg;
    return *this;
  }
  Type & set__is_complete(
    const bool & _arg)
  {
    this->is_complete = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__multisensor_calibration_interface__srv__CalibrationMetaData_Response
    std::shared_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__multisensor_calibration_interface__srv__CalibrationMetaData_Response
    std::shared_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CalibrationMetaData_Response_ & other) const
  {
    if (this->calib_type != other.calib_type) {
      return false;
    }
    if (this->robot_ws_path != other.robot_ws_path) {
      return false;
    }
    if (this->calib_ws_path != other.calib_ws_path) {
      return false;
    }
    if (this->calib_target_file_path != other.calib_target_file_path) {
      return false;
    }
    if (this->src_sensor_name != other.src_sensor_name) {
      return false;
    }
    if (this->src_topic_name != other.src_topic_name) {
      return false;
    }
    if (this->src_frame_id != other.src_frame_id) {
      return false;
    }
    if (this->ref_sensor_name != other.ref_sensor_name) {
      return false;
    }
    if (this->ref_topic_name != other.ref_topic_name) {
      return false;
    }
    if (this->ref_frame_id != other.ref_frame_id) {
      return false;
    }
    if (this->base_frame_id != other.base_frame_id) {
      return false;
    }
    if (this->is_complete != other.is_complete) {
      return false;
    }
    return true;
  }
  bool operator!=(const CalibrationMetaData_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CalibrationMetaData_Response_

// alias to use template instance with default allocator
using CalibrationMetaData_Response =
  multisensor_calibration_interface::srv::CalibrationMetaData_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace multisensor_calibration_interface


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__multisensor_calibration_interface__srv__CalibrationMetaData_Event __attribute__((deprecated))
#else
# define DEPRECATED__multisensor_calibration_interface__srv__CalibrationMetaData_Event __declspec(deprecated)
#endif

namespace multisensor_calibration_interface
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct CalibrationMetaData_Event_
{
  using Type = CalibrationMetaData_Event_<ContainerAllocator>;

  explicit CalibrationMetaData_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit CalibrationMetaData_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<multisensor_calibration_interface::srv::CalibrationMetaData_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<multisensor_calibration_interface::srv::CalibrationMetaData_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    multisensor_calibration_interface::srv::CalibrationMetaData_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const multisensor_calibration_interface::srv::CalibrationMetaData_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::CalibrationMetaData_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      multisensor_calibration_interface::srv::CalibrationMetaData_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__multisensor_calibration_interface__srv__CalibrationMetaData_Event
    std::shared_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__multisensor_calibration_interface__srv__CalibrationMetaData_Event
    std::shared_ptr<multisensor_calibration_interface::srv::CalibrationMetaData_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CalibrationMetaData_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const CalibrationMetaData_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CalibrationMetaData_Event_

// alias to use template instance with default allocator
using CalibrationMetaData_Event =
  multisensor_calibration_interface::srv::CalibrationMetaData_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace multisensor_calibration_interface

namespace multisensor_calibration_interface
{

namespace srv
{

struct CalibrationMetaData
{
  using Request = multisensor_calibration_interface::srv::CalibrationMetaData_Request;
  using Response = multisensor_calibration_interface::srv::CalibrationMetaData_Response;
  using Event = multisensor_calibration_interface::srv::CalibrationMetaData_Event;
};

}  // namespace srv

}  // namespace multisensor_calibration_interface

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CALIBRATION_META_DATA__STRUCT_HPP_
