// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from multisensor_calibration_interface:srv/CalibrationMetaData.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/srv/calibration_meta_data.hpp"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CALIBRATION_META_DATA__TRAITS_HPP_
#define MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CALIBRATION_META_DATA__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "multisensor_calibration_interface/srv/detail/calibration_meta_data__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace multisensor_calibration_interface
{

namespace srv
{

inline void to_flow_style_yaml(
  const CalibrationMetaData_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CalibrationMetaData_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CalibrationMetaData_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace multisensor_calibration_interface

namespace rosidl_generator_traits
{

[[deprecated("use multisensor_calibration_interface::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const multisensor_calibration_interface::srv::CalibrationMetaData_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  multisensor_calibration_interface::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use multisensor_calibration_interface::srv::to_yaml() instead")]]
inline std::string to_yaml(const multisensor_calibration_interface::srv::CalibrationMetaData_Request & msg)
{
  return multisensor_calibration_interface::srv::to_yaml(msg);
}

template<>
inline const char * data_type<multisensor_calibration_interface::srv::CalibrationMetaData_Request>()
{
  return "multisensor_calibration_interface::srv::CalibrationMetaData_Request";
}

template<>
inline const char * name<multisensor_calibration_interface::srv::CalibrationMetaData_Request>()
{
  return "multisensor_calibration_interface/srv/CalibrationMetaData_Request";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::srv::CalibrationMetaData_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<multisensor_calibration_interface::srv::CalibrationMetaData_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<multisensor_calibration_interface::srv::CalibrationMetaData_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace multisensor_calibration_interface
{

namespace srv
{

inline void to_flow_style_yaml(
  const CalibrationMetaData_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: calib_type
  {
    out << "calib_type: ";
    rosidl_generator_traits::value_to_yaml(msg.calib_type, out);
    out << ", ";
  }

  // member: robot_ws_path
  {
    out << "robot_ws_path: ";
    rosidl_generator_traits::value_to_yaml(msg.robot_ws_path, out);
    out << ", ";
  }

  // member: calib_ws_path
  {
    out << "calib_ws_path: ";
    rosidl_generator_traits::value_to_yaml(msg.calib_ws_path, out);
    out << ", ";
  }

  // member: calib_target_file_path
  {
    out << "calib_target_file_path: ";
    rosidl_generator_traits::value_to_yaml(msg.calib_target_file_path, out);
    out << ", ";
  }

  // member: src_sensor_name
  {
    out << "src_sensor_name: ";
    rosidl_generator_traits::value_to_yaml(msg.src_sensor_name, out);
    out << ", ";
  }

  // member: src_topic_name
  {
    out << "src_topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.src_topic_name, out);
    out << ", ";
  }

  // member: src_frame_id
  {
    out << "src_frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.src_frame_id, out);
    out << ", ";
  }

  // member: ref_sensor_name
  {
    out << "ref_sensor_name: ";
    rosidl_generator_traits::value_to_yaml(msg.ref_sensor_name, out);
    out << ", ";
  }

  // member: ref_topic_name
  {
    out << "ref_topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.ref_topic_name, out);
    out << ", ";
  }

  // member: ref_frame_id
  {
    out << "ref_frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.ref_frame_id, out);
    out << ", ";
  }

  // member: base_frame_id
  {
    out << "base_frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.base_frame_id, out);
    out << ", ";
  }

  // member: is_complete
  {
    out << "is_complete: ";
    rosidl_generator_traits::value_to_yaml(msg.is_complete, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CalibrationMetaData_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: calib_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "calib_type: ";
    rosidl_generator_traits::value_to_yaml(msg.calib_type, out);
    out << "\n";
  }

  // member: robot_ws_path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot_ws_path: ";
    rosidl_generator_traits::value_to_yaml(msg.robot_ws_path, out);
    out << "\n";
  }

  // member: calib_ws_path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "calib_ws_path: ";
    rosidl_generator_traits::value_to_yaml(msg.calib_ws_path, out);
    out << "\n";
  }

  // member: calib_target_file_path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "calib_target_file_path: ";
    rosidl_generator_traits::value_to_yaml(msg.calib_target_file_path, out);
    out << "\n";
  }

  // member: src_sensor_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "src_sensor_name: ";
    rosidl_generator_traits::value_to_yaml(msg.src_sensor_name, out);
    out << "\n";
  }

  // member: src_topic_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "src_topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.src_topic_name, out);
    out << "\n";
  }

  // member: src_frame_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "src_frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.src_frame_id, out);
    out << "\n";
  }

  // member: ref_sensor_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ref_sensor_name: ";
    rosidl_generator_traits::value_to_yaml(msg.ref_sensor_name, out);
    out << "\n";
  }

  // member: ref_topic_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ref_topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.ref_topic_name, out);
    out << "\n";
  }

  // member: ref_frame_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ref_frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.ref_frame_id, out);
    out << "\n";
  }

  // member: base_frame_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "base_frame_id: ";
    rosidl_generator_traits::value_to_yaml(msg.base_frame_id, out);
    out << "\n";
  }

  // member: is_complete
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_complete: ";
    rosidl_generator_traits::value_to_yaml(msg.is_complete, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CalibrationMetaData_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace multisensor_calibration_interface

namespace rosidl_generator_traits
{

[[deprecated("use multisensor_calibration_interface::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const multisensor_calibration_interface::srv::CalibrationMetaData_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  multisensor_calibration_interface::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use multisensor_calibration_interface::srv::to_yaml() instead")]]
inline std::string to_yaml(const multisensor_calibration_interface::srv::CalibrationMetaData_Response & msg)
{
  return multisensor_calibration_interface::srv::to_yaml(msg);
}

template<>
inline const char * data_type<multisensor_calibration_interface::srv::CalibrationMetaData_Response>()
{
  return "multisensor_calibration_interface::srv::CalibrationMetaData_Response";
}

template<>
inline const char * name<multisensor_calibration_interface::srv::CalibrationMetaData_Response>()
{
  return "multisensor_calibration_interface/srv/CalibrationMetaData_Response";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::srv::CalibrationMetaData_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<multisensor_calibration_interface::srv::CalibrationMetaData_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<multisensor_calibration_interface::srv::CalibrationMetaData_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace multisensor_calibration_interface
{

namespace srv
{

inline void to_flow_style_yaml(
  const CalibrationMetaData_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CalibrationMetaData_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CalibrationMetaData_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace multisensor_calibration_interface

namespace rosidl_generator_traits
{

[[deprecated("use multisensor_calibration_interface::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const multisensor_calibration_interface::srv::CalibrationMetaData_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  multisensor_calibration_interface::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use multisensor_calibration_interface::srv::to_yaml() instead")]]
inline std::string to_yaml(const multisensor_calibration_interface::srv::CalibrationMetaData_Event & msg)
{
  return multisensor_calibration_interface::srv::to_yaml(msg);
}

template<>
inline const char * data_type<multisensor_calibration_interface::srv::CalibrationMetaData_Event>()
{
  return "multisensor_calibration_interface::srv::CalibrationMetaData_Event";
}

template<>
inline const char * name<multisensor_calibration_interface::srv::CalibrationMetaData_Event>()
{
  return "multisensor_calibration_interface/srv/CalibrationMetaData_Event";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::srv::CalibrationMetaData_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<multisensor_calibration_interface::srv::CalibrationMetaData_Event>
  : std::integral_constant<bool, has_bounded_size<multisensor_calibration_interface::srv::CalibrationMetaData_Request>::value && has_bounded_size<multisensor_calibration_interface::srv::CalibrationMetaData_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<multisensor_calibration_interface::srv::CalibrationMetaData_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<multisensor_calibration_interface::srv::CalibrationMetaData>()
{
  return "multisensor_calibration_interface::srv::CalibrationMetaData";
}

template<>
inline const char * name<multisensor_calibration_interface::srv::CalibrationMetaData>()
{
  return "multisensor_calibration_interface/srv/CalibrationMetaData";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::srv::CalibrationMetaData>
  : std::integral_constant<
    bool,
    has_fixed_size<multisensor_calibration_interface::srv::CalibrationMetaData_Request>::value &&
    has_fixed_size<multisensor_calibration_interface::srv::CalibrationMetaData_Response>::value
  >
{
};

template<>
struct has_bounded_size<multisensor_calibration_interface::srv::CalibrationMetaData>
  : std::integral_constant<
    bool,
    has_bounded_size<multisensor_calibration_interface::srv::CalibrationMetaData_Request>::value &&
    has_bounded_size<multisensor_calibration_interface::srv::CalibrationMetaData_Response>::value
  >
{
};

template<>
struct is_service<multisensor_calibration_interface::srv::CalibrationMetaData>
  : std::true_type
{
};

template<>
struct is_service_request<multisensor_calibration_interface::srv::CalibrationMetaData_Request>
  : std::true_type
{
};

template<>
struct is_service_response<multisensor_calibration_interface::srv::CalibrationMetaData_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CALIBRATION_META_DATA__TRAITS_HPP_
