// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from multisensor_calibration_interface:srv/CameraIntrinsics.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/srv/camera_intrinsics.h"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CAMERA_INTRINSICS__STRUCT_H_
#define MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CAMERA_INTRINSICS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in srv/CameraIntrinsics in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__CameraIntrinsics_Request
{
  uint8_t structure_needs_at_least_one_member;
} multisensor_calibration_interface__srv__CameraIntrinsics_Request;

// Struct for a sequence of multisensor_calibration_interface__srv__CameraIntrinsics_Request.
typedef struct multisensor_calibration_interface__srv__CameraIntrinsics_Request__Sequence
{
  multisensor_calibration_interface__srv__CameraIntrinsics_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__CameraIntrinsics_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'intrinsics'
#include "sensor_msgs/msg/detail/camera_info__struct.h"
// Member 'image_state'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/CameraIntrinsics in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__CameraIntrinsics_Response
{
  sensor_msgs__msg__CameraInfo intrinsics;
  /// String indicating the state of the input images
  rosidl_runtime_c__String image_state;
} multisensor_calibration_interface__srv__CameraIntrinsics_Response;

// Struct for a sequence of multisensor_calibration_interface__srv__CameraIntrinsics_Response.
typedef struct multisensor_calibration_interface__srv__CameraIntrinsics_Response__Sequence
{
  multisensor_calibration_interface__srv__CameraIntrinsics_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__CameraIntrinsics_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  multisensor_calibration_interface__srv__CameraIntrinsics_Event__request__MAX_SIZE = 1
};
// response
enum
{
  multisensor_calibration_interface__srv__CameraIntrinsics_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/CameraIntrinsics in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__CameraIntrinsics_Event
{
  service_msgs__msg__ServiceEventInfo info;
  multisensor_calibration_interface__srv__CameraIntrinsics_Request__Sequence request;
  multisensor_calibration_interface__srv__CameraIntrinsics_Response__Sequence response;
} multisensor_calibration_interface__srv__CameraIntrinsics_Event;

// Struct for a sequence of multisensor_calibration_interface__srv__CameraIntrinsics_Event.
typedef struct multisensor_calibration_interface__srv__CameraIntrinsics_Event__Sequence
{
  multisensor_calibration_interface__srv__CameraIntrinsics_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__CameraIntrinsics_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CAMERA_INTRINSICS__STRUCT_H_
