// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from multisensor_calibration_interface:srv/CameraIntrinsics.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/srv/camera_intrinsics.hpp"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CAMERA_INTRINSICS__TRAITS_HPP_
#define MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CAMERA_INTRINSICS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "multisensor_calibration_interface/srv/detail/camera_intrinsics__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace multisensor_calibration_interface
{

namespace srv
{

inline void to_flow_style_yaml(
  const CameraIntrinsics_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraIntrinsics_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraIntrinsics_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace multisensor_calibration_interface

namespace rosidl_generator_traits
{

[[deprecated("use multisensor_calibration_interface::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const multisensor_calibration_interface::srv::CameraIntrinsics_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  multisensor_calibration_interface::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use multisensor_calibration_interface::srv::to_yaml() instead")]]
inline std::string to_yaml(const multisensor_calibration_interface::srv::CameraIntrinsics_Request & msg)
{
  return multisensor_calibration_interface::srv::to_yaml(msg);
}

template<>
inline const char * data_type<multisensor_calibration_interface::srv::CameraIntrinsics_Request>()
{
  return "multisensor_calibration_interface::srv::CameraIntrinsics_Request";
}

template<>
inline const char * name<multisensor_calibration_interface::srv::CameraIntrinsics_Request>()
{
  return "multisensor_calibration_interface/srv/CameraIntrinsics_Request";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::srv::CameraIntrinsics_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<multisensor_calibration_interface::srv::CameraIntrinsics_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<multisensor_calibration_interface::srv::CameraIntrinsics_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'intrinsics'
#include "sensor_msgs/msg/detail/camera_info__traits.hpp"

namespace multisensor_calibration_interface
{

namespace srv
{

inline void to_flow_style_yaml(
  const CameraIntrinsics_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: intrinsics
  {
    out << "intrinsics: ";
    to_flow_style_yaml(msg.intrinsics, out);
    out << ", ";
  }

  // member: image_state
  {
    out << "image_state: ";
    rosidl_generator_traits::value_to_yaml(msg.image_state, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraIntrinsics_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: intrinsics
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "intrinsics:\n";
    to_block_style_yaml(msg.intrinsics, out, indentation + 2);
  }

  // member: image_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "image_state: ";
    rosidl_generator_traits::value_to_yaml(msg.image_state, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraIntrinsics_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace multisensor_calibration_interface

namespace rosidl_generator_traits
{

[[deprecated("use multisensor_calibration_interface::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const multisensor_calibration_interface::srv::CameraIntrinsics_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  multisensor_calibration_interface::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use multisensor_calibration_interface::srv::to_yaml() instead")]]
inline std::string to_yaml(const multisensor_calibration_interface::srv::CameraIntrinsics_Response & msg)
{
  return multisensor_calibration_interface::srv::to_yaml(msg);
}

template<>
inline const char * data_type<multisensor_calibration_interface::srv::CameraIntrinsics_Response>()
{
  return "multisensor_calibration_interface::srv::CameraIntrinsics_Response";
}

template<>
inline const char * name<multisensor_calibration_interface::srv::CameraIntrinsics_Response>()
{
  return "multisensor_calibration_interface/srv/CameraIntrinsics_Response";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::srv::CameraIntrinsics_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<multisensor_calibration_interface::srv::CameraIntrinsics_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<multisensor_calibration_interface::srv::CameraIntrinsics_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace multisensor_calibration_interface
{

namespace srv
{

inline void to_flow_style_yaml(
  const CameraIntrinsics_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const CameraIntrinsics_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const CameraIntrinsics_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace multisensor_calibration_interface

namespace rosidl_generator_traits
{

[[deprecated("use multisensor_calibration_interface::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const multisensor_calibration_interface::srv::CameraIntrinsics_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  multisensor_calibration_interface::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use multisensor_calibration_interface::srv::to_yaml() instead")]]
inline std::string to_yaml(const multisensor_calibration_interface::srv::CameraIntrinsics_Event & msg)
{
  return multisensor_calibration_interface::srv::to_yaml(msg);
}

template<>
inline const char * data_type<multisensor_calibration_interface::srv::CameraIntrinsics_Event>()
{
  return "multisensor_calibration_interface::srv::CameraIntrinsics_Event";
}

template<>
inline const char * name<multisensor_calibration_interface::srv::CameraIntrinsics_Event>()
{
  return "multisensor_calibration_interface/srv/CameraIntrinsics_Event";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::srv::CameraIntrinsics_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<multisensor_calibration_interface::srv::CameraIntrinsics_Event>
  : std::integral_constant<bool, has_bounded_size<multisensor_calibration_interface::srv::CameraIntrinsics_Request>::value && has_bounded_size<multisensor_calibration_interface::srv::CameraIntrinsics_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<multisensor_calibration_interface::srv::CameraIntrinsics_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<multisensor_calibration_interface::srv::CameraIntrinsics>()
{
  return "multisensor_calibration_interface::srv::CameraIntrinsics";
}

template<>
inline const char * name<multisensor_calibration_interface::srv::CameraIntrinsics>()
{
  return "multisensor_calibration_interface/srv/CameraIntrinsics";
}

template<>
struct has_fixed_size<multisensor_calibration_interface::srv::CameraIntrinsics>
  : std::integral_constant<
    bool,
    has_fixed_size<multisensor_calibration_interface::srv::CameraIntrinsics_Request>::value &&
    has_fixed_size<multisensor_calibration_interface::srv::CameraIntrinsics_Response>::value
  >
{
};

template<>
struct has_bounded_size<multisensor_calibration_interface::srv::CameraIntrinsics>
  : std::integral_constant<
    bool,
    has_bounded_size<multisensor_calibration_interface::srv::CameraIntrinsics_Request>::value &&
    has_bounded_size<multisensor_calibration_interface::srv::CameraIntrinsics_Response>::value
  >
{
};

template<>
struct is_service<multisensor_calibration_interface::srv::CameraIntrinsics>
  : std::true_type
{
};

template<>
struct is_service_request<multisensor_calibration_interface::srv::CameraIntrinsics_Request>
  : std::true_type
{
};

template<>
struct is_service_response<multisensor_calibration_interface::srv::CameraIntrinsics_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__CAMERA_INTRINSICS__TRAITS_HPP_
