// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from multisensor_calibration_interface:srv/SensorExtrinsics.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "multisensor_calibration_interface/srv/sensor_extrinsics.h"


#ifndef MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__SENSOR_EXTRINSICS__STRUCT_H_
#define MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__SENSOR_EXTRINSICS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SENSOR_2_SENSOR'.
enum
{
  multisensor_calibration_interface__srv__SensorExtrinsics_Request__SENSOR_2_SENSOR = 0
};

/// Constant 'SENSOR_2_BASE_FRAME'.
enum
{
  multisensor_calibration_interface__srv__SensorExtrinsics_Request__SENSOR_2_BASE_FRAME = 1
};

/// Struct defined in srv/SensorExtrinsics in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__SensorExtrinsics_Request
{
  /// type of extrinsic to return
  /// SENSOR_2_SENSOR: extrinsics between source and reference sensor
  /// SENSOR_2_BASE_FRAME: extrinsics between source sensor and base frame. If latter is not available,
  /// the SENSOR_2_SENSOR extrinsics is returned.
  uint8_t extrinsic_type;
} multisensor_calibration_interface__srv__SensorExtrinsics_Request;

// Struct for a sequence of multisensor_calibration_interface__srv__SensorExtrinsics_Request.
typedef struct multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence
{
  multisensor_calibration_interface__srv__SensorExtrinsics_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'extrinsics'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in srv/SensorExtrinsics in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__SensorExtrinsics_Response
{
  geometry_msgs__msg__Pose extrinsics;
} multisensor_calibration_interface__srv__SensorExtrinsics_Response;

// Struct for a sequence of multisensor_calibration_interface__srv__SensorExtrinsics_Response.
typedef struct multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence
{
  multisensor_calibration_interface__srv__SensorExtrinsics_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  multisensor_calibration_interface__srv__SensorExtrinsics_Event__request__MAX_SIZE = 1
};
// response
enum
{
  multisensor_calibration_interface__srv__SensorExtrinsics_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/SensorExtrinsics in the package multisensor_calibration_interface.
typedef struct multisensor_calibration_interface__srv__SensorExtrinsics_Event
{
  service_msgs__msg__ServiceEventInfo info;
  multisensor_calibration_interface__srv__SensorExtrinsics_Request__Sequence request;
  multisensor_calibration_interface__srv__SensorExtrinsics_Response__Sequence response;
} multisensor_calibration_interface__srv__SensorExtrinsics_Event;

// Struct for a sequence of multisensor_calibration_interface__srv__SensorExtrinsics_Event.
typedef struct multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence
{
  multisensor_calibration_interface__srv__SensorExtrinsics_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} multisensor_calibration_interface__srv__SensorExtrinsics_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MULTISENSOR_CALIBRATION_INTERFACE__SRV__DETAIL__SENSOR_EXTRINSICS__STRUCT_H_
